/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, ContentChildren, EventEmitter, Input, Output, QueryList, ViewChildren } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormComponent, DynamicFormLayoutService, DynamicFormService, DynamicTemplateDirective, } from "@ng-dynamic-forms/core";
import { DynamicFoundationFormControlContainerComponent } from "./dynamic-foundation-form-control-container.component";
export class DynamicFoundationFormComponent extends DynamicFormComponent {
    /**
     * @param {?} formService
     * @param {?} layoutService
     */
    constructor(formService, layoutService) {
        super(formService, layoutService);
        this.formService = formService;
        this.layoutService = layoutService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationFormComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-form",
                template: "<dynamic-foundation-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\"\n                                 [group]=\"formGroup\"\n                                 [hidden]=\"model.hidden\"\n                                 [layout]=\"formLayout\"\n                                 [model]=\"model\"\n                                 [ngClass]=\"[getClass(model,'element','host'), getClass(model,'grid','host')]\"\n                                 [templates]=\"templates\"\n                                 (blur)=\"onEvent($event, 'blur')\"\n                                 (change)=\"onEvent($event, 'change')\"\n                                 (focus)=\"onEvent($event, 'focus')\"></dynamic-foundation-form-control>"
            }] }
];
/** @nocollapse */
DynamicFoundationFormComponent.ctorParameters = () => [
    { type: DynamicFormService, },
    { type: DynamicFormLayoutService, },
];
DynamicFoundationFormComponent.propDecorators = {
    "formGroup": [{ type: Input, args: ["group",] },],
    "formModel": [{ type: Input, args: ["model",] },],
    "formLayout": [{ type: Input, args: ["layout",] },],
    "blur": [{ type: Output },],
    "change": [{ type: Output },],
    "focus": [{ type: Output },],
    "templates": [{ type: ContentChildren, args: [DynamicTemplateDirective,] },],
    "components": [{ type: ViewChildren, args: [DynamicFoundationFormControlContainerComponent,] },],
};
function DynamicFoundationFormComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    DynamicFoundationFormComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    DynamicFoundationFormComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    DynamicFoundationFormComponent.propDecorators;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.formGroup;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.formModel;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.focus;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.templates;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.components;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.formService;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.layoutService;
}
//# sourceMappingURL=dynamic-foundation-form.component.js.map