/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, EventEmitter, Input, Output } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormControlComponent, DynamicFormGroupModel, DynamicFormLayoutService, DynamicFormValidationService } from "@ng-dynamic-forms/core";
export class DynamicFoundationFormGroupComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.bindId = true;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.customEvent = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationFormGroupComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-form-group",
                template: "<ng-container [formGroup]=\"group\">\n\n    <fieldset [dynamicId]=\"bindId && model.id\"\n              [formGroupName]=\"model.id\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\">\n\n        <legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend>\n\n        <dynamic-foundation-form-control *ngFor=\"let _model of model.group\"\n                                         [group]=\"control\"\n                                         [hidden]=\"_model.hidden\"\n                                         [layout]=\"layout\"\n                                         [model]=\"_model\"\n                                         [templates]=\"templates\"\n                                         [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model)]\"\n                                         (blur)=\"onBlur($event)\"\n                                         (change)=\"onChange($event)\"\n                                         (focus)=\"onFocus($event)\"\n                                         (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-foundation-form-control>\n    </fieldset>\n\n</ng-container>"
            }] }
];
/** @nocollapse */
DynamicFoundationFormGroupComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService, },
    { type: DynamicFormValidationService, },
];
DynamicFoundationFormGroupComponent.propDecorators = {
    "bindId": [{ type: Input },],
    "group": [{ type: Input },],
    "layout": [{ type: Input },],
    "model": [{ type: Input },],
    "templates": [{ type: Input },],
    "blur": [{ type: Output },],
    "change": [{ type: Output },],
    "customEvent": [{ type: Output },],
    "focus": [{ type: Output },],
};
function DynamicFoundationFormGroupComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    DynamicFoundationFormGroupComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    DynamicFoundationFormGroupComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    DynamicFoundationFormGroupComponent.propDecorators;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.bindId;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.templates;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.customEvent;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.focus;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.layoutService;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.validationService;
}
//# sourceMappingURL=dynamic-foundation-form-group.component.js.map